VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ExportItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Maintains a collection of all the functions present in the executable's export table"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"ExportItem"
Attribute VB_Ext_KEY = "Member0" ,"ExportItem"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mItems As Collection

Friend Function Add(FunctionName As String, Ordinal As Integer) As ExportItem
Dim objExpItem As ExportItem
    
    Set objExpItem = New ExportItem

    With objExpItem
        .FunctionName = FunctionName
        .Ordinal = Ordinal
    End With
    
    mItems.Add objExpItem, CStr(Ordinal)

    Set Add = objExpItem
    Set objExpItem = Nothing
End Function

Public Property Get Item(Index As Variant) As ExportItem
Attribute Item.VB_Description = "Returns a reference to an ExportItem entry"
Attribute Item.VB_UserMemId = 0
  Set Item = mItems(Index)
End Property

Public Property Get Count() As Long
Attribute Count.VB_Description = "Returns a count of functions in the dll's export table"
    Count = mItems.Count
End Property

Friend Sub Remove(Index As Variant)
    mItems.Remove Index
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mItems.[_NewEnum]
End Property

Private Sub Class_Initialize()
    Set mItems = New Collection
End Sub

Private Sub Class_Terminate()
    Set mItems = Nothing
End Sub

