VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Folders"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Folder"
Attribute VB_Ext_KEY = "Member0" ,"Folder"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public RootPath As String

Private mcolFolders As Collection

Public Function Add(Name As String) As Folder
On Error GoTo ErrHandler
    Dim clsFolder As Folder
    
    Set clsFolder = New Folder
    With clsFolder
        .Name = Name
        .Path = Me.RootPath & Name & "\"
    End With
    mcolFolders.Add clsFolder, Name
    Set Add = clsFolder
ExitHere:
    Set clsFolder = Nothing
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume ExitHere
End Function

Public Property Get Item(Index As Variant) As Folder
Attribute Item.VB_UserMemId = 0
  Set Item = mcolFolders(Index)
End Property

Public Property Get Count() As Long
    Count = mcolFolders.Count
End Property

Public Sub Remove(Index As Variant)
On Error GoTo ErrHandler
    mcolFolders.Remove Index
ExitHere:
    Exit Sub
ErrHandler:
    With Err
        .Raise .Number, .Source, .Description, .HelpFile, .HelpContext
    End With
    Resume ExitHere
End Sub

Private Function Enumerate() As IUnknown
    Set Enumerate = mcolFolders.[_NewEnum]
End Function

Private Sub Class_Initialize()
    Set mcolFolders = New Collection
End Sub

Private Sub Class_Terminate()
    Set mcolFolders = Nothing
End Sub

