VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CCommonDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type OPENFILENAME
  lStructSize As Long
  hWnd As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  Flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Private Declare Function GetOpenFileName Lib _
  "comdlg32.dll" Alias "GetOpenFileNameA" _
  (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib _
  "comdlg32.dll" Alias "GetSaveFileNameA" _
  (pOpenfilename As OPENFILENAME) As Long

Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_PATHMUSTEXIST = &H800
Private Const OFN_SAVE = 0
Private Const OFN_OPEN = 1

Private lngHwnd As Long
Private wMode As Integer
Private szDialogTitle As String
Private szFileName As String
Private szFilter As String
Private szDefDir As String
Private szDefExt As String
Private szFileTitle As String
Private szFileDir As String
Private intFilterIndex As Integer
Public Function Action() As String
  Dim x As Long, OFN As OPENFILENAME
  Call SetDefs
  With OFN
    .lStructSize = Len(OFN)
    .hWnd = lngHwnd
    .lpstrTitle = szDialogTitle
    .lpstrFile = szFileName & String$(250 - Len(szFileName), 0)
    .nMaxFile = 255
    .lpstrFileTitle = String$(255, 0)
    .nMaxFileTitle = 255
    .lpstrFilter = szFilter
    .nFilterIndex = intFilterIndex
    .lpstrInitialDir = szDefDir
    .lpstrDefExt = szDefExt
    If wMode = 1 Then
      OFN.Flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
      x = GetOpenFileName(OFN)
    Else
      OFN.Flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or OFN_PATHMUSTEXIST
      x = GetSaveFileName(OFN)
    End If
    If x <> 0 Then
      If InStr(.lpstrFile, Chr$(0)) > 0 Then
        szFileName = Left$(.lpstrFile, InStr(.lpstrFile, Chr$(0)) - 1)
        szFileTitle = Left$(.lpstrFileTitle, InStr(.lpstrFileTitle, Chr$(0)) - 1)
        Call getFile_Dir
      End If
    Else
      szFileName = ""
    End If
  End With
  Action = szFileName
End Function
'Pass a bar separated string and returns a Null separated string
Private Function NullSepString(ByVal BarString As String) As String
  Dim intInstr As Integer
  Const vbBar = "|"
  Do
    intInstr = InStr(BarString, vbBar)
    If intInstr > 0 Then Mid(BarString, intInstr, 1) = vbNullChar
  Loop While intInstr > 0
  NullSepString = BarString
End Function
Private Sub getFile_Dir()
  Dim intInstr As Integer
  intInstr = InStr(szFileName, szFileTitle) - 1
  szFileDir = Left(szFileName, intInstr)
End Sub

Property Let hWnd(SourceHwnd As Long)
  lngHwnd = SourceHwnd
End Property

Property Let ModeOpen(DialogMode As Boolean)
  wMode = DialogMode * -1
End Property
Property Let Title(DialogTitle As String)
  szDialogTitle = DialogTitle
End Property
Property Let FileName(DefaultFile As String)
  szFileName = DefaultFile
End Property
Property Get FileName() As String
  FileName = szFileName
End Property
Property Let Filter(FilterList As String)
  szFilter = NullSepString(FilterList)
End Property
Property Let StartDir(InitialDir As String)
  szDefDir = InitialDir
End Property
Property Let DefaultExtension(DefExt As String)
  szDefExt = DefExt
End Property
Property Get FileTitle()
  FileTitle = szFileTitle
End Property
Property Get FileDir() As String
  FileDir = szFileDir
End Property
Private Sub SetDefs()
  If lngHwnd = 0 Then lngHwnd = 0
  If szFilter = "" Then szFilter = NullSepString("All Files|*.*")
  If szDefDir = "" Then szDefDir = "C:\"
  If intFilterIndex = 0 Then intFilterIndex = 1
End Sub



