VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ExportItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains the name of the exported function and it's ordinal position in the executable"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

Private mstrFunctionName As String
Private mintOrdinal As Integer

Public Property Get FunctionName() As String
Attribute FunctionName.VB_Description = "The name of the function as it's present in the export table"
    FunctionName = mstrFunctionName
End Property

Public Property Get Ordinal() As Integer
Attribute Ordinal.VB_Description = "The ordinal position of the function in the executable."
    Ordinal = mintOrdinal
End Property

Friend Property Let FunctionName(Name As String)
    mstrFunctionName = Name
End Property

Friend Property Let Ordinal(Value As Integer)
    mintOrdinal = Value
End Property

