VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4050
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5175
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   4050
   ScaleWidth      =   5175
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtSearchPath 
      Height          =   285
      Left            =   1215
      TabIndex        =   9
      Text            =   "C:\"
      Top             =   540
      Width           =   2805
   End
   Begin VB.TextBox txtSearchCriteria 
      Height          =   285
      Left            =   1215
      TabIndex        =   8
      Text            =   "*.txt"
      Top             =   180
      Width           =   2805
   End
   Begin VB.CheckBox chkLocalDrivesOnly 
      Caption         =   "Local Drives Only?"
      Height          =   285
      Left            =   2250
      TabIndex        =   7
      Top             =   945
      Width           =   1770
   End
   Begin VB.CheckBox chkIncludeSubFolders 
      Caption         =   "Include Subfolders?"
      Height          =   330
      Left            =   225
      TabIndex        =   6
      Top             =   945
      Width           =   1905
   End
   Begin VB.CommandButton cmdFileInfo 
      Caption         =   "Get Info"
      Height          =   315
      Left            =   4095
      TabIndex        =   5
      Top             =   585
      Width           =   990
   End
   Begin VB.ListBox List1 
      Height          =   1620
      Left            =   225
      TabIndex        =   2
      Top             =   1665
      Width           =   4875
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Search"
      Height          =   315
      Left            =   4095
      TabIndex        =   1
      Top             =   180
      Width           =   990
   End
   Begin VB.Label lblFileCount 
      Height          =   285
      Left            =   225
      TabIndex        =   12
      Top             =   3330
      Width           =   2040
   End
   Begin VB.Label Label4 
      Caption         =   "In Path:"
      Height          =   285
      Left            =   180
      TabIndex        =   11
      Top             =   540
      Width           =   960
   End
   Begin VB.Label Label3 
      Caption         =   "Search for:"
      Height          =   285
      Left            =   180
      TabIndex        =   10
      Top             =   180
      Width           =   960
   End
   Begin VB.Label lblCaption 
      Caption         =   "Press Escape to cancel"
      Height          =   240
      Left            =   3375
      TabIndex        =   4
      Top             =   3345
      Visible         =   0   'False
      Width           =   1740
   End
   Begin VB.Label Label2 
      Caption         =   "Double click to view details:"
      Height          =   315
      Left            =   225
      TabIndex        =   3
      Top             =   1350
      Width           =   2040
   End
   Begin VB.Label Label1 
      Height          =   330
      Left            =   225
      TabIndex        =   0
      Top             =   3645
      Width           =   4890
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents clsFO As FileSystemEx.FileObject
Attribute clsFO.VB_VarHelpID = -1
Private clsFiles As FileSystemEx.Files
Private clsFile As FileSystemEx.File
Private mblnCancel As Boolean
Private mblnSingleFile As Boolean

Friend Property Get SearchItem() As FileSystemEx.File
    If mblnSingleFile Then
        Set SearchItem = clsFile
    Else
        Set SearchItem = clsFO.FilesFound( _
                                    Me.List1)
    End If
End Property

Private Sub clsFO_Found(ByVal FileInfo As FileSystemEx.File)
    Me.List1.AddItem FileInfo.FullPath
    Me.lblFileCount.Caption = "Found " & clsFO.FilesFound.Count & " file(s)."
    Me.lblFileCount.Refresh
End Sub

Private Sub clsFO_SearchStatus(ByVal CurrentFolder As String, Cancel As Boolean)
    Me.Label1.Caption = clsFO.CompactPath(CurrentFolder, 50)
    Me.Label1.Refresh
    Cancel = mblnCancel
End Sub

Private Sub cmdFileInfo_Click()
On Error GoTo ErrHandler
Dim strFile As String
Dim clsCommDlg As CCommonDialog

    Me.List1.Clear
    Set clsCommDlg = New CCommonDialog
    With clsCommDlg
        .hWnd = Me.hWnd
        .StartDir = CurDir()
        .Title = "Please select a file to view details"
        .Filter = "All Files (*.*)|*.*"
        .ModeOpen = True
        strFile = .Action
    End With
    
    If Len(strFile) > 0 Then
        Set clsFiles = New FileSystemEx.Files
        Set clsFile = clsFiles.GetInfoForFile(strFile)
        mblnSingleFile = True
        frmItemDetails.Show modal:=1, OwnerForm:=Me
    End If
    
ExitHere:
    Me.lblCaption.Visible = False
    Exit Sub
ErrHandler:
    MsgBox "Error " & Err.Number & vbCrLf & Err.Description, _
        vbOKOnly + vbCritical, Err.Source
    Resume ExitHere
End Sub

Private Sub Command1_Click()
On Error GoTo ErrHandler
Dim strFileSpec As String

    mblnCancel = False
    Me.lblCaption.Visible = True
    Me.lblFileCount.Caption = vbNullString
    Me.Refresh
    Set clsFO = New FileSystemEx.FileObject
    Me.List1.Clear
    mblnSingleFile = False
    With clsFO
        .SearchPath = Me.txtSearchPath.Text
        .IncludeSubFolders = (Me.chkIncludeSubFolders = vbChecked)
        .LocalDrivesOnly = (Me.chkLocalDrivesOnly = vbChecked)
        strFileSpec = Me.txtSearchCriteria
        If Len(Trim$(strFileSpec)) > 0 Then
            .FindFile strFileSpec
        End If
    End With

ExitHere:
    Me.lblCaption.Visible = False
    Me.Label1.Caption = vbNullString
    Exit Sub
ErrHandler:
    MsgBox "Error " & Err.Number & vbCrLf & Err.Description, _
        vbOKOnly + vbCritical, Err.Source
    Resume ExitHere
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    mblnCancel = True
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set clsFO = Nothing
    Set clsFiles = Nothing
End Sub

Private Sub List1_DblClick()
    frmItemDetails.Show modal:=1, OwnerForm:=Me
End Sub
