VERSION 5.00
Begin VB.Form frmItemDetails 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Item Details"
   ClientHeight    =   5730
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6195
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5730
   ScaleWidth      =   6195
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.ListBox lstExportTable 
      Height          =   1230
      Left            =   90
      TabIndex        =   18
      Top             =   4410
      Width           =   6090
   End
   Begin VB.Label Label2 
      Caption         =   "Export Table:"
      Height          =   285
      Left            =   135
      TabIndex        =   19
      Top             =   4140
      Width           =   1230
   End
   Begin VB.Label Label1 
      Caption         =   "Version:"
      Height          =   315
      Index           =   8
      Left            =   150
      TabIndex        =   17
      Top             =   2325
      Width           =   1440
   End
   Begin VB.Label lblVersion 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   16
      Top             =   2325
      Width           =   4305
   End
   Begin VB.Label lblTimeLastWritten 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   15
      Top             =   3675
      Width           =   4305
   End
   Begin VB.Label lblTimeLastAccessed 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   14
      Top             =   3225
      Width           =   4305
   End
   Begin VB.Label lblTimeCreated 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   13
      Top             =   2775
      Width           =   4305
   End
   Begin VB.Label lblFileType 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   12
      Top             =   1875
      Width           =   4300
   End
   Begin VB.Label lblSize 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   11
      Top             =   1425
      Width           =   4300
   End
   Begin VB.Label lblAttributes 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   10
      Top             =   975
      Width           =   4300
   End
   Begin VB.Label lblFullPath 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   9
      Top             =   525
      Width           =   4300
   End
   Begin VB.Label lblFileName 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1800
      TabIndex        =   8
      Top             =   75
      Width           =   4300
   End
   Begin VB.Label Label1 
      Caption         =   "Type:"
      Height          =   315
      Index           =   7
      Left            =   150
      TabIndex        =   7
      Top             =   1875
      Width           =   1440
   End
   Begin VB.Label Label1 
      Caption         =   "Size:"
      Height          =   315
      Index           =   6
      Left            =   150
      TabIndex        =   6
      Top             =   1425
      Width           =   1440
   End
   Begin VB.Label Label1 
      Caption         =   "Time Last Written:"
      Height          =   315
      Index           =   5
      Left            =   150
      TabIndex        =   5
      Top             =   3675
      Width           =   1440
   End
   Begin VB.Label Label1 
      Caption         =   "Time Last Accessed:"
      Height          =   315
      Index           =   4
      Left            =   150
      TabIndex        =   4
      Top             =   3225
      Width           =   1590
   End
   Begin VB.Label Label1 
      Caption         =   "Time Created:"
      Height          =   315
      Index           =   3
      Left            =   150
      TabIndex        =   3
      Top             =   2775
      Width           =   1440
   End
   Begin VB.Label Label1 
      Caption         =   "Attributes:"
      Height          =   315
      Index           =   2
      Left            =   150
      TabIndex        =   2
      Top             =   975
      Width           =   1440
   End
   Begin VB.Label Label1 
      Caption         =   "Full Path:"
      Height          =   315
      Index           =   1
      Left            =   150
      TabIndex        =   1
      Top             =   525
      Width           =   1440
   End
   Begin VB.Label Label1 
      Caption         =   "File Name:"
      Height          =   315
      Index           =   0
      Left            =   150
      TabIndex        =   0
      Top             =   75
      Width           =   1440
   End
End
Attribute VB_Name = "frmItemDetails"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private clsFile As FileSystemEx.File

Private Sub Form_Load()
On Error GoTo ErrHandler
Dim i As Integer

    Set clsFile = Form1.SearchItem
    With clsFile
        Me.lblAttributes.Caption = .AttributesString
        Me.lblFileName.Caption = .Name
        Me.lblFileType.Caption = .TypeName
        Me.lblFullPath.Caption = .FullPath
        Me.lblSize.Caption = Format$(.Size, "###,###,###") & " bytes"
        Me.lblTimeCreated.Caption = .TimeCreated
        Me.lblTimeLastAccessed.Caption = .TimeLastAccessed
        Me.lblTimeLastWritten.Caption = .TimeLastWritten
        If Len(.MajorVersion) > 0 Then
            Me.lblVersion.Caption = .MajorVersion & "." & .MinorVersion _
                                                & "." & .MajorBuild & "." & .MinorBuild
        End If
        
        Me.lstExportTable.Clear
        If .ExportItems.Count > 0 Then
            Me.lstExportTable.Enabled = True
            For i = 1 To .ExportItems.Count
                Me.lstExportTable.AddItem .ExportItems(i).FunctionName
            Next
        Else
            Me.lstExportTable.Enabled = False
        End If
    End With
ExitHere:
    Exit Sub
ErrHandler:
    Me.lstExportTable.Enabled = False
    Resume ExitHere
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set clsFile = Nothing
End Sub
